<template>
  <div
    class="h-screen flex w-full bg-img vx-row no-gutter items-center justify-center"
    id="page-login"
  >
    <div id="overlay" />
    <div class="vx-col sm:m-0 m-4">
      <vx-card>
        <div slot="no-body" class="full-page-bg-color" style="border-radius: 14px;">
          <div class="vx-row no-gutter justify-center items-center">
            <div class="vx-col w-full d-theme-dark-bg" style="border-radius: 14px;">
              <div class="p-8 login-tabs-container">
                <div class="vx-card__title mb-4">
                  <img class="logo" src="~@/assets/images/logo/skyriff-logo.png" />
                  <p>Please login to your account</p>
                </div>

                <div>
                  <vs-input
                    name="email"
                    icon-no-border
                    icon="icon icon-user"
                    icon-pack="feather"
                    v-model="email"
                    class="w-full"
                  />

                  <vs-input
                    type="password"
                    name="password"
                    icon-no-border
                    icon="icon icon-lock"
                    icon-pack="feather"
                    v-model="password"
                    class="w-full mt-6"
                  />

                  <div class="flex flex-wrap justify-between my-5">
                    <vs-checkbox v-model="checkbox_remember_me" class="mb-3">Remember Me</vs-checkbox>
                    <router-link class="forgot-pass-link" to>Forgot Password?</router-link>
                  </div>
                  <div class="w-full flex justify-center">
                    <vs-button class="action-btn" style="min-width: 140px;" @click="login">Login</vs-button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </vx-card>
    </div>
  </div>
</template>

<script lang="ts">
import api from "@/api/auth.api.ts";
import { Component, Watch } from "vue-property-decorator";
import { notificationMixin } from "@/mixins";
import { USER_TOKEN, PILOT_ID, USER_NAME } from "@/helpers/constants";
import Cookies from "js-cookie";

@Component
export default class Login extends notificationMixin {
  private email = "";
  private password = "";
  private checkbox_remember_me = false;

  private async login() {
    await api.login(this.email, this.password).then(response => {
      if (response.status === 200) {
        Cookies.set(USER_TOKEN, response.data.token);
        Cookies.set(USER_NAME, response.data.name);
        Cookies.set(PILOT_ID, response.data.pilotId);

        this.$store.dispatch("vuexy/updateUserInfo", {
          displayName: response.data.name
        });
        this.$router.push("/");
      }
    });
  }
}
</script>

<style lang="scss">
#page-login {
  #overlay {
    position: absolute;
    width: 100vw;
    height: 100vh;
    background-image: url("../../assets/images/pages/dots-overlay-yellow.png");
    background-repeat: repeat;
    opacity: 0.5;
  }

  .vx-card__title {
    min-width: 320px;

    @media (max-width: 576px) {
      min-width: 0;
    }
  }
  .logo {
    width: 130px;
    margin: auto;
    margin-bottom: 20px;
  }

  .forgot-pass-link {
    color: #646464;
    transition: all 0.3s ease;

    &:hover {
      color: rgba(var(--vs-primary), 1) !important;
    }
  }
}
</style>
